% HP filtr
% ********

function [x_eq, x_gap] = hp(x, lambda)

% vytvoreni sloupcoveho vektoru
x = x(:);

% priprava delky vystupnich vektoru
x_eq  = NaN * ones(size(x));
x_gap = NaN * ones(size(x));


u = find(~isnan(x));   % isnan - zjisteni zda neni NaN
                       % find - vytvoreni poradi bey yapocitani NaN

if length(u) < 3   % pro filtrovani jsou treba vzdy 3 pozorovani
  return
else
  sample = u(1):u(end);   % prevod na radkovy vektor
  samplelen = length(sample);
end

x_ = x(sample);   % vytahne z vektoru x tolik prvku kolik urcil vektor u

vx = zeros([samplelen-2, 1]);  % vytvori spravnou delku
T = zeros([samplelen-2, 1]);
mh = zeros([samplelen+2, 1]);

% filtrovani
vx = x_(1:end-2) - 2*x_(2:end-1) + x_(3:end);   % uprava puvodnich hodnot

T(1:3) = [6*lambda+1, -4*lambda, lambda];
T = toeplitz(T);    % symetricka (Hermitianska) Toeplitzova matice:
                    % jeli T = [a b c], pak toeplitz(T) = [a b c
                    %                                      b a b
                    %                                      c b a]

mh(3:end-2) = T \ vx;   % POZOR opacne deleni

% vyfiltrovana odchylka
tmp = lambda*(mh(1:end-2) - 2*mh(2:end-1) + mh(3:end));

% vystupni vektory HP filtru
x_eq(sample)  = x(sample) - tmp;
x_gap(sample) = tmp;

return